#include"env.h"

void finish(char* msg) {
	printf("\nFATAL ERROR: %s; terminating\n",msg);
	fflush(stdout);
	MPI_Finalize();
	exit(EXIT_FAILURE);
}

#define MAX_NODE_NAME 128
#define MY_NAME_TAG 2000

void printNodeNames(MPI_Comm comm) {
	char node_name[MAX_NODE_NAME];
	int name_len;
	int rank,crank; /* my rank and remote node's rank */
	int comm_size;
	int i_am_the_master;
	MPI_Status Status;
	MPI_Comm_size(comm,&comm_size);
	MPI_Comm_rank(comm,&rank);
	if(rank < 0 || rank >= comm_size)
		return;	/* possibly we are not in this comm */
	i_am_the_master = (rank == 0);
	MPI_Get_processor_name(node_name,&name_len);

	if(i_am_the_master) {
		printf("Node 0: %s (master)\n",node_name);		
		for(crank = 1; crank < comm_size; crank ++) {
			MPI_Recv(node_name,MAX_NODE_NAME,MPI_CHAR,crank,MY_NAME_TAG,comm,&Status);
			printf("Node %d: %s\n",crank,node_name);		
			}
	}
	else 	
		MPI_Send(node_name,strlen(node_name)+1,MPI_CHAR,0,MY_NAME_TAG,comm);
}

